/*Ŀ
 ݳ Program Name: FMVIEW.PRG        Copyright: Gallagher Computing Corp  
 ݳ Date Created: 08/28/92           Language: Clipper 5.0               
 ݳ Time Created: 19:08:50             Author: Kevin S Gallagher         
 
             */
#include "include1.ch"
****************************************************************************
* View ASCII files  CALLED from DirBrowser() *
****************************************************************************
function ASCIIVIEW( FileToView )
  local SaveFullScreen()
  local cDefColor:= setcolor( 'w+/b,n/w' )
  local cIt:=CURDRV+":\"+CURDIR(CURDRV)+"\"+FileToView
  scroll()
  @00,0        say PADC(DISPHEAD,80)              color "W+/BG"
  @MAXROW(),0  say PADC("Press {ESC} to exit",80) color "W+/RB"
  @MAXROW(),1  say UPPER(FileToView)              color "W+/RB"
  FT_DFSETUP(cIt,2,0,maxrow()-2,maxcol(),1,23,48,'e'+CHR(143),.F.,5,132,8192)
  FT_DISPFILE()  ;  FT_DFCLOSE()
  memory(0)
  setcolor( cDefColor )
  RestFullScreen()
Return Nil

function DVIEW(DBFFile)
   local SaveFullScreen()
   local cDefColor:= setcolor( 'w+/bg,n/w' )
   local b, c, n, key, stru_
   BoxShad( 2, 2, 21, 75, "W+/BG" )
   USE (DBFFile) SHARED NEW
   IF NETERR()   ;   BREAK   ;   RETURN Nil   ;   ENDIF
   b:=TBrowsedb(3,3,19,74)
   b:colorSpec:= "W+/BG,W+/RB"
   b:headSep   := ''
   b:colSep    := '  '
   b:footSep   := ''
   @20,5  say 'Filename:'    color 'w+/bg'
   @20,15 say UPPER(DBFFile) color 'gr+/bg'
   c:=TBColumnNew()
   c:block := { || recno() }
   b:addColumn(c)
   stru_ := dbstruct()
   for n := 1 to LEN(stru_)
      c:=TBColumnNew()
      c:heading := Proper(lower(stru_[n,DBS_NAME]))
      if stru_[n, DBS_TYPE] <> "M"
         c:block := fieldblock(stru_[n, DBS_NAME])
      else
         c:block := { || " Memo " }
      endif
      b:addColumn(c)
   next n
   **************************************************************************
   * Show our position and how many records there are. *
   **************************************************************************
   @20,50 say PADC(ltrim(str(recno())) + "/"+;
                   ltrim(str(lastrec())),15)     color 'w+/bg'
   do whil key != K_ESC
      do while ! b:stabilize() .and. (key := inkey()) == 0
      enddo
      @20,50 say PADC(ltrim(str(recno())) + "/"+;
                      ltrim(str(lastrec())),15)  color 'w+/bg'
      if b:hittop .or. b:hitbottom
         tone(25,1)
      endif
      if b:stable
         key:=inkey(0)
      endif
      do case
            case key = K_UP              ;  b:up()
            case key = K_DOWN            ;  b:down()
            case key = K_LEFT            ;  b:left()
            case key = K_RIGHT           ;  b:right()
            case key = K_F2              ;  DBFstruc()
            case key = K_F1              ;  HelpScreen( 1 )
      endcase
   enddo
   dbCloseArea()
   setcolor( cDefColor )
   RestFullScreen()
return Nil

****************************************************************************
* Display the current .dbf structure in a TBrowse *
****************************************************************************
static function DBFstruc
   local SaveFullScreen()
   local element:= 1, key := 0
   local aArray := dbstruct()
   local b, c
   b:= TBrowseNew(7, 26, 14, 50 )
   BoxShad( 6, 25, 15, 51,'w+/br' )
   b:colorSpec:='gr+/br, w+/n, w+/br, n/n'
   b:headSep := ""
   b:colSep  := "  "
   b:footSep := ""
   b:goTopBlock   := {|| element := 1 }
   b:goBottomBlock:= {|| element := len(aArray) }
   b:skipBlock    := {|n| ArraySkip(len(aArray), @element, n ) }
   c:= TBColumnNew("NAME", {|| aArray[element, 1] } )
   c:colorblock := {|| { 3, 2 } }
   c:width:= 10
   b:AddColumn( c )
   c:= TBColumnNew("TYPE", {|| PADC(aArray[element, 2],3) } )
   c:colorblock := {|| { 3, 2 } }
   b:AddColumn( c )
   c:= TBColumnNew("LEN",  {|| STR(aArray[element, 3],2) } )
   c:colorblock := {|| { 3, 2 } }
   b:AddColumn( c )
   BEGIN SEQUENCE
      DO WHILE .T.
         do while .not. b:stabilize()          ;     enddo
         if b:stabilize() ; key:=inkey(0)      ;     endif
         DO CASE
            case key == K_UP                   ;     b:up()
            case key == K_DOWN                 ;     b:down()
            case key == K_PGDN                 ;     b:pageDown()
            case key == K_PGUP                 ;     b:pageUp()
            case key == K_F1                   ;     HelpScreen( 2 )
            case key == K_ESC                  ;     BREAK
         ENDCASE
      ENDDO
   END SEQUENCE
   RestFullScreen()
return nil

function ZVIEW(ZipFile)
    local SaveFullScreen()
    local cZipView:= Rtrim(ZipFile)
    ZMain( cZipView )
    RestFullScreen()
return nil


